/* ***********************************************************
 * This file was automatically generated on 2021-05-06.      *
 *                                                           *
 * LabVIEW Bindings Version 2.1.29                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Measures two DC currents between 0mA and 20mA (IEC 60381-1)
	/// </summary>
	public class BrickletIndustrialDual020mA : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 228;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "Industrial Dual 0-20mA Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_CURRENT = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_CURRENT_CALLBACK_PERIOD = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_CURRENT_CALLBACK_PERIOD = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_CURRENT_CALLBACK_THRESHOLD = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_CURRENT_CALLBACK_THRESHOLD = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_DEBOUNCE_PERIOD = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_DEBOUNCE_PERIOD = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_SAMPLE_RATE = 8;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_SAMPLE_RATE = 9;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;

		private const int CALLBACK_CURRENT = 10;

		private const int CALLBACK_CURRENT_REACHED = 11;


		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OFF = 'x';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OUTSIDE = 'o';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_INSIDE = 'i';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_SMALLER = '<';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_GREATER = '>';

		/// <summary>
		/// </summary>
		public const byte SAMPLE_RATE_240_SPS = 0;

		/// <summary>
		/// </summary>
		public const byte SAMPLE_RATE_60_SPS = 1;

		/// <summary>
		/// </summary>
		public const byte SAMPLE_RATE_15_SPS = 2;

		/// <summary>
		/// </summary>
		public const byte SAMPLE_RATE_4_SPS = 3;


		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletIndustrialDual020mA.SetCurrentCallbackPeriod"/>. The parameter is the current of the
		///  sensor.
		///  
		///  The <see cref="Tinkerforge.BrickletIndustrialDual020mA.CurrentCallback"/> callback is only triggered if the current has changed since the
		///  last triggering.
		/// </summary>
		public event CurrentEventHandler CurrentCallback;
		/// <summary>
		/// </summary>
		public delegate void CurrentEventHandler(BrickletIndustrialDual020mA sender, byte sensor, int current);

		/// <summary>
		/// </summary>
		public event CurrentEventHandler Current // for backward compatibility
		{
			add { CurrentCallback += value; }
			remove { CurrentCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletIndustrialDual020mA.SetCurrentCallbackThreshold"/> is reached.
		///  The parameter is the current of the sensor.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletIndustrialDual020mA.SetDebouncePeriod"/>.
		/// </summary>
		public event CurrentReachedEventHandler CurrentReachedCallback;
		/// <summary>
		/// </summary>
		public delegate void CurrentReachedEventHandler(BrickletIndustrialDual020mA sender, byte sensor, int current);

		/// <summary>
		/// </summary>
		public event CurrentReachedEventHandler CurrentReached // for backward compatibility
		{
			add { CurrentReachedCallback += value; }
			remove { CurrentReachedCallback -= value; }
		}

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletIndustrialDual020mA(string uid, IPConnection ipcon) : base(uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 0;

			callbackWrappers[CALLBACK_CURRENT] = new CallbackWrapper(OnCurrentCallback);
			callbackWrappers[CALLBACK_CURRENT_REACHED] = new CallbackWrapper(OnCurrentReachedCallback);


			responseExpected[FUNCTION_GET_CURRENT] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_CURRENT_CALLBACK_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_CURRENT_CALLBACK_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_CURRENT_CALLBACK_THRESHOLD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_CURRENT_CALLBACK_THRESHOLD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_SAMPLE_RATE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_SAMPLE_RATE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;

			ipcon.AddDevice(this);
		}

		/// <summary>
		///  Returns the current of the specified sensor.
		///  
		///  It is possible to detect if an IEC 60381-1 compatible sensor is connected
		///  and if it works properly.
		///  
		///  If the returned current is below 4mA, there is likely no sensor connected
		///  or the sensor may be defect. If the returned current is over 20mA, there might
		///  be a short circuit or the sensor may be defect.
		///  
		///  If you want to get the current periodically, it is recommended to use the
		///  <see cref="Tinkerforge.BrickletIndustrialDual020mA.CurrentCallback"/> callback and set the period with
		///  <see cref="Tinkerforge.BrickletIndustrialDual020mA.SetCurrentCallbackPeriod"/>.
		/// </summary>
		public int GetCurrent(byte sensor)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_GET_CURRENT);
			LEConverter.To((byte)sensor, 8, request);

			byte[] response = SendRequest(request, 12);

			return LEConverter.IntFrom(8, response);
		}

		/// <summary>
		///  Sets the period with which the <see cref="Tinkerforge.BrickletIndustrialDual020mA.CurrentCallback"/> callback is triggered
		///  periodically for the given sensor. A value of 0 turns the callback off.
		///  
		///  The <see cref="Tinkerforge.BrickletIndustrialDual020mA.CurrentCallback"/> callback is only triggered if the current has changed since the
		///  last triggering.
		/// </summary>
		public void SetCurrentCallbackPeriod(byte sensor, long period)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(13, FUNCTION_SET_CURRENT_CALLBACK_PERIOD);
			LEConverter.To((byte)sensor, 8, request);
			LEConverter.To((int)period, 9, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletIndustrialDual020mA.SetCurrentCallbackPeriod"/>.
		/// </summary>
		public long GetCurrentCallbackPeriod(byte sensor)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_GET_CURRENT_CALLBACK_PERIOD);
			LEConverter.To((byte)sensor, 8, request);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletIndustrialDual020mA.CurrentReachedCallback"/> callback for the given
		///  sensor.
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the current is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the current is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the current is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the current is greater than the min value (max is ignored)"
		///  </code>
		/// </summary>
		public void SetCurrentCallbackThreshold(byte sensor, char option, int min, int max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(18, FUNCTION_SET_CURRENT_CALLBACK_THRESHOLD);
			LEConverter.To((byte)sensor, 8, request);
			LEConverter.To((char)option, 9, request);
			LEConverter.To((int)min, 10, request);
			LEConverter.To((int)max, 14, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletIndustrialDual020mA.SetCurrentCallbackThreshold"/>.
		/// </summary>
		public void GetCurrentCallbackThreshold(byte sensor, out char option, out int min, out int max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_GET_CURRENT_CALLBACK_THRESHOLD);
			LEConverter.To((byte)sensor, 8, request);

			byte[] response = SendRequest(request, 17);

			option = LEConverter.CharFrom(8, response);
			min = LEConverter.IntFrom(9, response);
			max = LEConverter.IntFrom(13, response);
		}

		/// <summary>
		///  Sets the period with which the threshold callback
		///  
		///  * <see cref="Tinkerforge.BrickletIndustrialDual020mA.CurrentReachedCallback"/>
		///  
		///  is triggered, if the threshold
		///  
		///  * <see cref="Tinkerforge.BrickletIndustrialDual020mA.SetCurrentCallbackThreshold"/>
		///  
		///  keeps being reached.
		/// </summary>
		public void SetDebouncePeriod(long debounce)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_DEBOUNCE_PERIOD);
			LEConverter.To((int)debounce, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the debounce period as set by <see cref="Tinkerforge.BrickletIndustrialDual020mA.SetDebouncePeriod"/>.
		/// </summary>
		public long GetDebouncePeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_DEBOUNCE_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the sample rate to either 240, 60, 15 or 4 samples per second.
		///  The resolution for the rates is 12, 14, 16 and 18 bit respectively.
		///  
		///  <code>
		///   "Value", "Description"
		///  
		///   "0",    "240 samples per second, 12 bit resolution"
		///   "1",    "60 samples per second, 14 bit resolution"
		///   "2",    "15 samples per second, 16 bit resolution"
		///   "3",    "4 samples per second, 18 bit resolution"
		///  </code>
		/// </summary>
		public void SetSampleRate(byte rate)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_SET_SAMPLE_RATE);
			LEConverter.To((byte)rate, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the sample rate as set by <see cref="Tinkerforge.BrickletIndustrialDual020mA.SetSampleRate"/>.
		/// </summary>
		public byte GetSampleRate()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_SAMPLE_RATE);

			byte[] response = SendRequest(request, 9);

			return LEConverter.ByteFrom(8, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
		///  A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
		///  position 'z'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request, 33);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnCurrentCallback(byte[] response)
		{
			if (response.Length != 13)
			{
				return; // silently ignoring callback with wrong length
			}

			byte sensor = LEConverter.ByteFrom(8, response);
			int current = LEConverter.IntFrom(9, response);
			var handler = CurrentCallback;

			if (handler != null)
			{
				handler(this, sensor, current);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnCurrentReachedCallback(byte[] response)
		{
			if (response.Length != 13)
			{
				return; // silently ignoring callback with wrong length
			}

			byte sensor = LEConverter.ByteFrom(8, response);
			int current = LEConverter.IntFrom(9, response);
			var handler = CurrentReachedCallback;

			if (handler != null)
			{
				handler(this, sensor, current);
			}
		}
	}
}
