/* ***********************************************************
 * This file was automatically generated on 2021-05-06.      *
 *                                                           *
 * LabVIEW Bindings Version 2.1.29                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  20x4 character alphanumeric display with blue backlight
	/// </summary>
	public class BrickletLCD20x4 : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 212;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "LCD 20x4 Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_WRITE_LINE = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_CLEAR_DISPLAY = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_BACKLIGHT_ON = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_BACKLIGHT_OFF = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_IS_BACKLIGHT_ON = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_CONFIG = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_CONFIG = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_IS_BUTTON_PRESSED = 8;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_CUSTOM_CHARACTER = 11;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_CUSTOM_CHARACTER = 12;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_DEFAULT_TEXT = 13;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_DEFAULT_TEXT = 14;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_DEFAULT_TEXT_COUNTER = 15;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_DEFAULT_TEXT_COUNTER = 16;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;

		private const int CALLBACK_BUTTON_PRESSED = 9;

		private const int CALLBACK_BUTTON_RELEASED = 10;



		/// <summary>
		///  This callback is triggered when a button is pressed. The parameter is
		///  the number of the button (0 to 2 or 0 to 3 since hardware version 1.2).
		/// </summary>
		public event ButtonPressedEventHandler ButtonPressedCallback;
		/// <summary>
		/// </summary>
		public delegate void ButtonPressedEventHandler(BrickletLCD20x4 sender, byte button);

		/// <summary>
		/// </summary>
		public event ButtonPressedEventHandler ButtonPressed // for backward compatibility
		{
			add { ButtonPressedCallback += value; }
			remove { ButtonPressedCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered when a button is released. The parameter is
		///  the number of the button (0 to 2 or 0 to 3 since hardware version 1.2).
		/// </summary>
		public event ButtonReleasedEventHandler ButtonReleasedCallback;
		/// <summary>
		/// </summary>
		public delegate void ButtonReleasedEventHandler(BrickletLCD20x4 sender, byte button);

		/// <summary>
		/// </summary>
		public event ButtonReleasedEventHandler ButtonReleased // for backward compatibility
		{
			add { ButtonReleasedCallback += value; }
			remove { ButtonReleasedCallback -= value; }
		}

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletLCD20x4(string uid, IPConnection ipcon) : base(uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 2;

			callbackWrappers[CALLBACK_BUTTON_PRESSED] = new CallbackWrapper(OnButtonPressedCallback);
			callbackWrappers[CALLBACK_BUTTON_RELEASED] = new CallbackWrapper(OnButtonReleasedCallback);


			responseExpected[FUNCTION_WRITE_LINE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_CLEAR_DISPLAY] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_BACKLIGHT_ON] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_BACKLIGHT_OFF] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_IS_BACKLIGHT_ON] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_CONFIG] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_CONFIG] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_IS_BUTTON_PRESSED] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_CUSTOM_CHARACTER] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_CUSTOM_CHARACTER] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_DEFAULT_TEXT] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_DEFAULT_TEXT] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_DEFAULT_TEXT_COUNTER] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_DEFAULT_TEXT_COUNTER] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;

			ipcon.AddDevice(this);
		}

		/// <summary>
		///  Writes text to a specific line with a specific position.
		///  The text can have a maximum of 20 characters.
		///  
		///  For example: (0, 7, "Hello") will write *Hello* in the middle of the
		///  first line of the display.
		///  
		///  The display uses a special charset that includes all ASCII characters except
		///  backslash and tilde. The LCD charset also includes several other non-ASCII characters, see
		///  the `charset specification &lt;https://github.com/Tinkerforge/lcd-20x4-bricklet/raw/master/datasheets/standard_charset.pdf&gt;`__
		///  for details. The Unicode example above shows how to specify non-ASCII characters
		///  and how to translate from Unicode to the LCD charset.
		/// </summary>
		public void WriteLine(byte line, byte position, string text)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(30, FUNCTION_WRITE_LINE);
			LEConverter.To((byte)line, 8, request);
			LEConverter.To((byte)position, 9, request);
			LEConverter.To((string)text, 10, 20, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Deletes all characters from the display.
		/// </summary>
		public void ClearDisplay()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_CLEAR_DISPLAY);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Turns the backlight on.
		/// </summary>
		public void BacklightOn()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_BACKLIGHT_ON);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Turns the backlight off.
		/// </summary>
		public void BacklightOff()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_BACKLIGHT_OFF);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns *true* if the backlight is on and *false* otherwise.
		/// </summary>
		public bool IsBacklightOn()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_IS_BACKLIGHT_ON);

			byte[] response = SendRequest(request, 9);

			return LEConverter.BoolFrom(8, response);
		}

		/// <summary>
		///  Configures if the cursor (shown as "_") should be visible and if it
		///  should be blinking (shown as a blinking block). The cursor position
		///  is one character behind the the last text written with
		///  <see cref="Tinkerforge.BrickletLCD20x4.WriteLine"/>.
		/// </summary>
		public void SetConfig(bool cursor, bool blinking)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(10, FUNCTION_SET_CONFIG);
			LEConverter.To((bool)cursor, 8, request);
			LEConverter.To((bool)blinking, 9, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the configuration as set by <see cref="Tinkerforge.BrickletLCD20x4.SetConfig"/>.
		/// </summary>
		public void GetConfig(out bool cursor, out bool blinking)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_CONFIG);

			byte[] response = SendRequest(request, 10);

			cursor = LEConverter.BoolFrom(8, response);
			blinking = LEConverter.BoolFrom(9, response);
		}

		/// <summary>
		///  Returns *true* if the button (0 to 2 or 0 to 3 since hardware version 1.2)
		///  is pressed.
		///  
		///  If you want to react on button presses and releases it is recommended to use
		///  the <see cref="Tinkerforge.BrickletLCD20x4.ButtonPressedCallback"/> and <see cref="Tinkerforge.BrickletLCD20x4.ButtonReleasedCallback"/> callbacks.
		/// </summary>
		public bool IsButtonPressed(byte button)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_IS_BUTTON_PRESSED);
			LEConverter.To((byte)button, 8, request);

			byte[] response = SendRequest(request, 9);

			return LEConverter.BoolFrom(8, response);
		}

		/// <summary>
		///  The LCD 20x4 Bricklet can store up to 8 custom characters. The characters
		///  consist of 5x8 pixels and can be addressed with the index 0-7. To describe
		///  the pixels, the first 5 bits of 8 bytes are used. For example, to make
		///  a custom character "H", you should transfer the following:
		///  
		///  * ``character[0] = 0b00010001`` (decimal value 17)
		///  * ``character[1] = 0b00010001`` (decimal value 17)
		///  * ``character[2] = 0b00010001`` (decimal value 17)
		///  * ``character[3] = 0b00011111`` (decimal value 31)
		///  * ``character[4] = 0b00010001`` (decimal value 17)
		///  * ``character[5] = 0b00010001`` (decimal value 17)
		///  * ``character[6] = 0b00010001`` (decimal value 17)
		///  * ``character[7] = 0b00000000`` (decimal value 0)
		///  
		///  The characters can later be written with <see cref="Tinkerforge.BrickletLCD20x4.WriteLine"/> by using the
		///  characters with the byte representation 8 ("\\x08" or "\\u0008") to 15
		///  ("\\x0F" or "\\u000F").
		///  
		///  You can play around with the custom characters in Brick Viewer version
		///  since 2.0.1.
		///  
		///  Custom characters are stored by the LCD in RAM, so they have to be set
		///  after each startup.
		///  
		///  .. versionadded:: 2.0.1$nbsp;(Plugin)
		/// </summary>
		public void SetCustomCharacter(byte index, byte[] character)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(17, FUNCTION_SET_CUSTOM_CHARACTER);
			LEConverter.To((byte)index, 8, request);
			LEConverter.To((byte[])character, 9, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the custom character for a given index, as set with
		///  <see cref="Tinkerforge.BrickletLCD20x4.SetCustomCharacter"/>.
		///  
		///  .. versionadded:: 2.0.1$nbsp;(Plugin)
		/// </summary>
		public byte[] GetCustomCharacter(byte index)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_GET_CUSTOM_CHARACTER);
			LEConverter.To((byte)index, 8, request);

			byte[] response = SendRequest(request, 16);

			return LEConverter.ByteArrayFrom(8, response, 8);
		}

		/// <summary>
		///  Sets the default text for lines 0-3. The max number of characters
		///  per line is 20.
		///  
		///  The default text is shown on the LCD, if the default text counter
		///  expires, see <see cref="Tinkerforge.BrickletLCD20x4.SetDefaultTextCounter"/>.
		///  
		///  .. versionadded:: 2.0.2$nbsp;(Plugin)
		/// </summary>
		public void SetDefaultText(byte line, string text)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(29, FUNCTION_SET_DEFAULT_TEXT);
			LEConverter.To((byte)line, 8, request);
			LEConverter.To((string)text, 9, 20, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the default text for a given line (0-3) as set by
		///  <see cref="Tinkerforge.BrickletLCD20x4.SetDefaultText"/>.
		///  
		///  .. versionadded:: 2.0.2$nbsp;(Plugin)
		/// </summary>
		public string GetDefaultText(byte line)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_GET_DEFAULT_TEXT);
			LEConverter.To((byte)line, 8, request);

			byte[] response = SendRequest(request, 28);

			return LEConverter.StringFrom(8, response, 20);
		}

		/// <summary>
		///  Sets the default text counter. This counter is decremented each
		///  ms by the LCD firmware. If the counter reaches 0, the default text
		///  (see <see cref="Tinkerforge.BrickletLCD20x4.SetDefaultText"/>) is shown on the LCD.
		///  
		///  This functionality can be used to show a default text if the controlling
		///  program crashes or the connection is interrupted.
		///  
		///  A possible approach is to call <see cref="Tinkerforge.BrickletLCD20x4.SetDefaultTextCounter"/> every
		///  minute with the parameter 1000*60*2 (2 minutes). In this case the
		///  default text will be shown no later than 2 minutes after the
		///  controlling program crashes.
		///  
		///  A negative counter turns the default text functionality off.
		///  
		///  .. versionadded:: 2.0.2$nbsp;(Plugin)
		/// </summary>
		public void SetDefaultTextCounter(int counter)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_DEFAULT_TEXT_COUNTER);
			LEConverter.To((int)counter, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the current value of the default text counter.
		///  
		///  .. versionadded:: 2.0.2$nbsp;(Plugin)
		/// </summary>
		public int GetDefaultTextCounter()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_DEFAULT_TEXT_COUNTER);

			byte[] response = SendRequest(request, 12);

			return LEConverter.IntFrom(8, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
		///  A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
		///  position 'z'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request, 33);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnButtonPressedCallback(byte[] response)
		{
			if (response.Length != 9)
			{
				return; // silently ignoring callback with wrong length
			}

			byte button = LEConverter.ByteFrom(8, response);
			var handler = ButtonPressedCallback;

			if (handler != null)
			{
				handler(this, button);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnButtonReleasedCallback(byte[] response)
		{
			if (response.Length != 9)
			{
				return; // silently ignoring callback with wrong length
			}

			byte button = LEConverter.ByteFrom(8, response);
			var handler = ButtonReleasedCallback;

			if (handler != null)
			{
				handler(this, button);
			}
		}
	}
}
